<?php

/************************************************************************/
/* Evolution Persian: Advanced Content Management System                */
/* ============================================                         */
/*                                                                      */
/* Copyright (c) 2007 by WebAlfa                                        */
/* http://webalfa.ir                                                    */
/*                                                                      */
/* Evolution Persian Installer V2.0.7       		                    */
/************************************************************************/

// Set flag that this is a parent file
define( "_VALID_MOS", 1 );

// Include common.php
require_once( 'common.php' );
require_once( './includes/database.php' );

$DBhostname = mosGetParam( $_POST, 'DBhostname', '' );
$DBuserName = mosGetParam( $_POST, 'DBuserName', '' );
$DBpassword = mosGetParam( $_POST, 'DBpassword', '' );
$DBname  	= mosGetParam( $_POST, 'DBname', '' );
$DBcreated	= intval( mosGetParam( $_POST, 'DBcreated', 0 ) );
$BUPrefix = 'old_';
$configArray['sitename'] = trim( mosGetParam( $_POST, 'sitename', '' ) );

$database = null;

$errors = array();
if (!$DBcreated){
	if (!$DBhostname || !$DBuserName || !$DBname) {
		db_err ("stepBack3","The database details provided are incorrect and/or empty.");
	}

	$database = new database( $DBhostname, $DBuserName, $DBpassword, '', '', false );
	$test = $database->getErrorMsg();

	if (!$database->_resource) {
		db_err ('stepBack2','The password and username provided are incorrect.');
	}

	if($DBname == '') {
		db_err ('stepBack','The database name provided is empty.');
	}

	// Does this code actually do anything???
	$configArray['DBhostname'] = $DBhostname;
	$configArray['DBuserName'] = $DBuserName;
	$configArray['DBpassword'] = $DBpassword;
	$configArray['DBname']	 = $DBname;

	$sql = "CREATE DATABASE `$DBname`";
	$database->setQuery( $sql );
	$database->query();
	$test = $database->getErrorNum();

	if ($test != 0 && $test != 1007) {
		db_err( 'stepBack', 'A database error occurred: ' . $database->getErrorMsg() );
	}

	// db is now new or existing, create the db object connector to do the serious work
	$database = new database( $DBhostname, $DBuserName, $DBpassword, $DBname );

	// delete existing mos table if exists
	$query = "SHOW TABLES FROM `$DBname`";
	$database->setQuery( $query );
	$errors = array();
	if ($tables = $database->loadResultArray()) {
		foreach ($tables as $table) {
				$query = "DROP TABLE IF EXISTS `$table`";
				$database->setQuery( $query );
				$database->query();
				if ($database->getErrorNum()) {
					$errors[$database->getQuery()] = $database->getErrorMsg();
				}
		}
	}

	populate_db( $database, 'install.sql' );
	$DBcreated = 1;
}

function db_err($step, $alert) {
	global $DBhostname,$DBuserName,$DBpassword,$DBname;
	echo "<form name=\"$step\" method=\"post\" action=\"install1.php\">
	<input type=\"hidden\" name=\"DBhostname\" value=\"$DBhostname\">
	<input type=\"hidden\" name=\"DBuserName\" value=\"$DBuserName\">
	<input type=\"hidden\" name=\"DBpassword\" value=\"$DBpassword\">
	<input type=\"hidden\" name=\"DBname\" value=\"$DBname\">
	</form>\n";
	//echo "<script>alert(\"$alert\"); window.history.go(-1);</script>";
	echo "<script>alert(\"$alert\"); document.location.href='install1.php';</script>";  
	exit();
}

/**
 * @param object
 * @param string File name
 */
function populate_db( &$database, $sqlfile='install.sql') {
	global $errors;

	$mqr = @get_magic_quotes_runtime();
	@set_magic_quotes_runtime(0);
	$query = fread( fopen( 'sql/' . $sqlfile, 'r' ), filesize( 'sql/' . $sqlfile ) );
	@set_magic_quotes_runtime($mqr);
	$pieces  = split_sql($query);

	for ($i=0; $i<count($pieces); $i++) {
		$pieces[$i] = trim($pieces[$i]);
		if(!empty($pieces[$i]) && $pieces[$i] != "#") {
			$database->setQuery( $pieces[$i] );
			if (!$database->query()) {
				$errors[] = array ( $database->getErrorMsg(), $pieces[$i] );
			}
		}
	}
}

/**
 * @param string
 */
function split_sql($sql) {
	$sql = trim($sql);
	$sql = ereg_replace("\n#[^\n]*\n", "\n", $sql);

	$buffer = array();
	$ret = array();
	$in_string = false;

	for($i=0; $i<strlen($sql)-1; $i++) {
		if($sql[$i] == ";" && !$in_string) {
			$ret[] = substr($sql, 0, $i);
			$sql = substr($sql, $i + 1);
			$i = 0;
		}

		if($in_string && ($sql[$i] == $in_string) && $buffer[1] != "\\") {
			$in_string = false;
		}
		elseif(!$in_string && ($sql[$i] == '"' || $sql[$i] == "'") && (!isset($buffer[0]) || $buffer[0] != "\\")) {
			$in_string = $sql[$i];
		}
		if(isset($buffer[1])) {
			$buffer[0] = $buffer[1];
		}
		$buffer[1] = $sql[$i];
	}

	if(!empty($sql)) {
		$ret[] = $sql;
	}
	return($ret);
}

$isErr = intval( count( $errors ) );

echo "<?xml version=\"1.0\" encoding=\"UTF-8\"?".">";
?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Evolution Persian Installer</title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<link rel="shortcut icon" href="../../images/favicon.ico" />
<link rel="stylesheet" href="install.css" type="text/css" />
<script type="text/javascript">
<!--
function check() {
	// form validation check
	var formValid = true;
	var f = document.form;
	if ( f.sitename.value == '' ) {
		alert('Please enter a Site Name');
		f.sitename.focus();
		formValid = false
	}
	return formValid;
}
//-->
</script>
</head>
<body onload="document.form.sitename.focus();">
<div id="wrapper">
	<div id="header">
	  <div id="phpnuke">
		<address dir="rtl" align="right"><font face="Tahoma"><span style="font-style: normal"><img src="header_install.png" alt="Evolution Persian Installation" /></span></font></address>
		</div>
	</div>
</div>

<div id="ctr" align="center">
	<form action="install2.php" method="post" name="form" id="form" onsubmit="return check();">
	<font face="Tahoma">
	<input type="hidden" name="DBhostname" value="<?php echo "$DBhostname"; ?>" />
	<input type="hidden" name="DBuserName" value="<?php echo "$DBuserName"; ?>" />
	<input type="hidden" name="DBpassword" value="<?php echo "$DBpassword"; ?>" />
	<input type="hidden" name="DBname" value="<?php echo "$DBname"; ?>" />
	<input type="hidden" name="DBcreated" value="<?php echo "$DBcreated"; ?>" />
	</font>
	<div class="install" style="width: 750px; height: 260px">
		<div id="stepbar" style="width: 170px; height: 218px">
	  <div class="step-off">
				<address dir="rtl" style="text-align: right">
					<font face="Tahoma" size="1">
					<span style="font-style: normal">&#1602;&#1583;&#1605; &#1575;&#1608;&#1604;</span></font></address>
			</div>
			<div class="step-on">
				<address dir="rtl" style="text-align: right">
					<font face="Tahoma" size="1">
					<span style="font-style: normal">&#1602;&#1583;&#1605;&nbsp; <span lang="fa">
					&#1583;&#1608;&#1605;</span></span></font></address>
			</div>
			<div class="step-off">
				<address dir="rtl" style="text-align: right">
					<font face="Tahoma" size="1">
					<span style="font-style: normal">&#1602;&#1583;&#1605;&nbsp; <span lang="fa">
					&#1587;&#1608;&#1605;</span></span></font></address>
			</div>
			<div class="step-off">
				<address dir="rtl" style="text-align: right">
					<font face="Tahoma" size="1">
					<span style="font-style: normal">&#1602;&#1583;&#1605;&nbsp; &#1670;&#1607;&#1575;&#1585;&#1605;</span></font></address>
			</div>
		</div>
		<div id="right" style="width: 545px; height: 218px">
		  <?php
			if ($isErr) {

				echo '';
				echo "<br/><br />: ط®ط·ط§<br />\n";
				// abrupt failure
				echo '<textarea rows="10" cols="90">';
				foreach($errors as $error) {
					echo "SQL=$error[0]:\n- - - - - - - - - -\n$error[1]\n= = = = = = = = = =\n\n";
				}
				echo '</textarea>';
				echo "</td></tr></font></div>\n";
  			} else {

				
?>  			
	  <div class="install-text" style="width: 529px; height: 165px">
				<div class="install-form" style="width: 100%; height: 62px">
					<div class="form-block">
						<div align="right">
						<table class="content2" id="table1" width="476">
							
					<p align="right" dir="rtl"><b>
							
					<span lang="fa"><font size="2">&nbsp;&#1606;&#1575;&#1605; &#1587;&#1575;&#1740;&#1578; &#1585;&#1575; &#1608;&#1575;&#1585;&#1583; &#1705;&#1606;&#1740;&#1583;</font></span><font size="2"> :</span></font></span></font></b></p>
					</address>
					<tr>
								<td width="377">
								<p dir="rtl">
								<span style="font-style: normal">
								<font face="Tahoma">
								<input class="inputbox" type="text" name="sitename" size="66" value="<?php echo "{$configArray['sitename']}"; ?>" /></font></span></td>
								<td align="center" valign="middle" width="89">
								<address dir="rtl" align="right">
									<span style="font-style: normal" lang="fa">
									<font face="Tahoma">&#1606;&#1575;&#1605; &#1587;&#1575;&#1740;&#1578; :</font></span></address>
								</td>
							</tr>
						</table></div>
						<font face="Tahoma">
<?php
  			} // if
?></font></div></div>
				<div class="clr">
					<div class="far-right">
						<address dir="rtl">&nbsp;</address></div>
					<div class="clr">
						<address align="right" dir="rtl">
						</address></div>
				</div>
				<p><div align="center" style="width: 53px; height: 37px">
                  <address dir="rtl">
                  <span style="font-style: normal"> <font face="Tahoma">
                  <?php if (!$isErr) { ?>
                    <input class="button" type="submit" name="next" value="بعد &gt;&gt;"/>
                  <?php } ?>
                    </font> </span>
                  </address>
		  </div>
	  </div>
								</div>
	</div>
	<div class="clr">
		<address dir="rtl" align="right">
		</address>
		</div>
	</form>
</div>
<div class="clr">
	<address dir="rtl" align="right">
	</address>
</div>
<font face="Tahoma">
</div>
</font>
<br>
<div class="ctr">
	<address dir="ltr">
<b><span style="font-style: normal"><font face="Tahoma"><span lang="en-us">
	Installer</span> By
		<a href="http://webalfa.ir/">WebAlfa</a><span lang="en-us"> Ported For 
Evolution Persian By <a href="http://webalfa.ir/">AliKing</a></span></font></span></b></address>
</div>
</body>
</html>